
//  MatoPanelApplet.java  (c) 2002-2006 Kari Laitinen

//  JPanel-luokkaan perustuva versio ohjelmasta MatoApplet.java


//  2006-01-24  Tiedosto luotu.
//  2006-10-19  Viimeisin muutos.

import java.awt.* ;
import java.util.* ;
import javax.swing.* ;

class MatoPanel extends JPanel implements Runnable
{
   Thread  tahdistussaie ;

   boolean  saietta_on_suoritettava  =  false ;

   Color   kaytossa_oleva_vari      =  Color.red ;

   int  madon_paikka_x  ;
   int  madon_paikka_y  =  150 ;

   int  madon_pituus    =  100 ;
   int  madon_korkeus   =   30 ;

   int  apletin_leveys, apletin_korkeus ;

   public MatoPanel( int annettu_apletin_leveys,
                     int annettu_apletin_korkeus )
   {
      apletin_leveys   =  annettu_apletin_leveys ;
      apletin_korkeus  =  annettu_apletin_korkeus ;
   }

   public void kaynnista_saie()
   {
      if ( tahdistussaie  ==  null )
      {
         tahdistussaie  =  new  Thread( this ) ;
         saietta_on_suoritettava  =  true ;

         tahdistussaie.start() ;
      }
   }

   public void lopeta_saie()
   {
      if ( tahdistussaie  !=  null )
      {
         tahdistussaie.interrupt() ;
         saietta_on_suoritettava  =  false ;
         tahdistussaie  =  null ;
      }
   }

   public void run()
   {
      while ( saietta_on_suoritettava  ==  true )
      {
         madon_paikka_x  =  50 ;
         madon_pituus    = 100 ;

         repaint() ;

         lepuuta_tata_saietta( 2000 ) ;

         while ( madon_paikka_x  +  madon_pituus  <  apletin_leveys  &&
                 saietta_on_suoritettava  ==  true )
         {
            for ( int venytyslaskuri  =  0 ;
                      venytyslaskuri  <  7 ;
                      venytyslaskuri  ++ )
            {
               madon_pituus  =  madon_pituus  + 5 ;

               repaint() ;
               lepuuta_tata_saietta( 50 ) ;
            }

            for ( int supistuslaskuri  =  0 ;
                      supistuslaskuri  <  7 ;
                      supistuslaskuri  ++ )
            {
               madon_pituus    =  madon_pituus    -  5 ;
               madon_paikka_x  =  madon_paikka_x  +  5 ;

               repaint() ;
               lepuuta_tata_saietta( 50 ) ;
            }
         }

         lepuuta_tata_saietta( 4000 ) ;
      }  
   }

   void  lepuuta_tata_saietta( int lepuutusaika_millisekunteina )
   {
      //  Ilman seuraavaa if-rakennetta syntyy sellainen ongelma
      //  ett sie ei pyshdy nopeasti mm. silloin kun matoa nyttv
      //  ikkuna minimoidaan. Esim. MatoOlioAppletissa tm metodi on
      //  kirjoitettu ilman if-rakennetta ja siin on sellainen ongelma
      //  ett jos ikkuna minimoidaan ja maksimoidaan heti pern madon
      //  ollessa ruudun keskivaiheilla, mato alkaa uuden sikeen 
      //  kynnistytty kyttyty hyvin omituisesti. Ilmeisesti tm
      //  johtuu siit ett sek uusi tahdistussie ett vanha sie
      //  muuttelevat yht aikaa madon pituutta ja madon x-paikkaa.
      //  Vanha sie jatkaa elmns kun saietta_on_suoritettava
      //  pannaan uutta siett varten arvoon true.

      if ( saietta_on_suoritettava  ==  true )
      {
         try
         {
            Thread.sleep( lepuutusaika_millisekunteina ) ;
            // System.out.print( " Z" ) ;  //  Rivi testausta varten
         }
         catch ( InterruptedException vangittu_poikkeus )
         {
            // System.out.print( " X" ) ;  //  Rivi testausta varten
         }
      }
   }

   public void paintComponent( Graphics graphics )
   {
      super.paintComponent( graphics ) ;

      graphics.setColor( kaytossa_oleva_vari ) ;

      graphics.fillRoundRect( madon_paikka_x, madon_paikka_y,
                              madon_pituus, madon_korkeus, 20, 20  ) ;
   }
}


public class MatoPanelApplet extends JApplet
{
   MatoPanel  paneeli_madolle ;

   public void init()
   {
      paneeli_madolle  =  new MatoPanel( getSize().width, getSize().height ) ; 
      getContentPane().add( paneeli_madolle ) ; 
   }

   public void start()
   {
      paneeli_madolle.kaynnista_saie() ;
   }

   public void stop()
   {
      paneeli_madolle.lopeta_saie() ;
   }

}










